# Written by Yaniv Erlich (erlich@cshl.edu)


package Hypergeom;
use strict;
use warnings;

our @ISA = ("Exporter");
our @EXPORT = qw(hypergeom gammln);

sub test {
    print hypergeom(1,101,2,100),"\n";
    #should print 0.0198
}

sub logfact {

    my $a = shift(@_);

   return gammln($a + 1.0);
}

sub hypergeom {
#calculates the probability of hypergeometric distribution
#like matlab notation
#(special in sample, total, special in total, sample)

    my ($i,$a,$n,$N) = @_;
    my $m = $a - $n;
    my $loghyp1 = logfact($m)+logfact($n)+logfact($N)+logfact($m+$n-$N);
    my $loghyp2 = logfact($i)+logfact($n-$i)+logfact($m+$i-$N)+logfact(+$N-$i)+logfact($m+$n);
    return exp($loghyp1 - $loghyp2);
}

sub gammln {
  my $xx = shift;
  my @cof = (76.18009172947146, -86.50532032941677,
             24.01409824083091, -1.231739572450155,
             0.12086509738661e-2, -0.5395239384953e-5);
  my $y = my $x = $xx;
  my $tmp = $x + 5.5;
  $tmp -= ($x + .5) * log($tmp);
  my $ser = 1.000000000190015;
  for my $j (0..5) {
     $ser += $cof[$j]/++$y;
  }
  -$tmp + log(2.5066282746310005*$ser/$x);
}
